loadScript("Config.js");
loadScript("ContactDao.js");
Application = Class.create();
Application.prototype = Object.extend(new Object(), {
	
	initialize: function(model) {
		this.model = model;
		
		this.config = new Config();
		Query.defaultDatasource = this.config.datasource;
		
		this.dao = new ContactDao(this.config);
	},
	
	addContact: function() {
		this.model.submitAction = "insertContact";
		this.model.contact = this.dao.getContactById(-1);
	},
	
	contactList: function() {
		this.model.contactList = this.dao.getContactList();
	},
	
	/*
	 * This method isn't exposed in the UI, it's just for showing how
	 * you can use a "list" QueryParam as well as a single value one.
	 */
	contactListByIds: function() {
		this.model.viewName = "contactList";
		this.model.contactList = this.dao.getContactListByIds(System.getParam("ids"));
	},
	
	deleteContact: function() {
		this.model.viewName = "redirect:contactList";
		this.model.contact = this.dao.deleteContact(System.getParam("id"));
	},
	
	editContact: function() {
		this.model.submitAction = "updateContact";
		this.model.contact = this.dao.getContactById(System.getParam("id"));
	},
	
	home: function() {
		this.model.viewName = "contactList";
		this.contactList();
	},
	
	insertContact: function() {
		this.model.viewName = "redirect:contactList";
		this.dao.createContact(System.getParam("name"), System.getParam("email"));
	},
	
	updateContact: function() {
		this.model.viewName = "redirect:contactList";
		this.dao.updateContact(System.getParam("id"), System.getParam("name"), System.getParam("email"));
	}
});